package com.brilliance.swift.mt2SwiftDto.camt053001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.vo.BankToCustomerStatement;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field86;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.List;

/**
 * @author zh
 * @create 2022-04-24 14:59
 */
public class Camt053001Parse86Field extends AbstractMt2SwiftDtoParseFields {

    private String name = "86";

    @Override
    public void parseFields() throws SwiftException {
        try {
            BankToCustomerStatement bankToCustomerStatement = context.get(BankToCustomerStatement.class);
            AbstractMT abstractMT = context.get(AbstractMT.class);
            List<Tag> tags = abstractMT.getSwiftMessage().getBlock4().getTags();
            if (tags.size() > 0) {
                if (name.equals(tags.get(tags.size()-1).getName())) {
                    Field86 field86 = new Field86(tags.get(tags.size()-1).getValue());
                    bankToCustomerStatement.setAdditionalStatementInformation(field86.getValue().replace("\r\n", ""));
                }
            }
        }catch (Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}
