package com.brilliance.swift.mt2SwiftDto.camt054001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.util.SwiftTransferUtil;
import com.brilliance.swift.vo.BankToCustomerDebitCreditNotification;
import com.brilliance.swift.vo.common.PartyAccount;
import com.prowidesoftware.swift.model.field.Field25;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt9xx.MT900;
import com.prowidesoftware.swift.model.mt9xx.MT910;

/**
 * @author zh
 * @create 2022-04-24 14:59
 */
public class Camt054001Parse25aField extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            BankToCustomerDebitCreditNotification bankToCustomerDebitCreditNotification = context.get(BankToCustomerDebitCreditNotification.class);
            if(context.get(AbstractMT.class).getMessageType().equals("900")){
                MT900 mt900 = (MT900) context.get(AbstractMT.class);
                Field25 field25 = mt900.getField25();
                if(field25!=null){
                   PartyAccount account =new PartyAccount();
                    if (SwiftTransferUtil.checkIbanAccount(field25.getValue())) {
                        account.setIbanAcct(field25.getValue());
                    } else {
                        account.setAccount(field25.getValue());
                    }
                   bankToCustomerDebitCreditNotification.setAccount(account);
                }
            }else {
                MT910 mt910 = (MT910) context.get(AbstractMT.class);
                Field25 field25 = mt910.getField25();
                if(field25!=null){
                    PartyAccount account =new PartyAccount();
                    account.setAccount(field25.getValue());
                    bankToCustomerDebitCreditNotification.setAccount(account);
                }
            }
        }catch (Exception e){
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}
