package com.brilliance.swift.mt2SwiftDto.pacs008001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.util.DateUtil;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.prowidesoftware.swift.model.field.Field13C;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt1xx.MT103;

import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import java.util.Date;
import java.util.List;

public class Pacs00801Parse13CField extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            MT103 mt103 = (MT103)context.get(AbstractMT.class);
            VoCustomerCreditTransfer customerCreditTransfer = context.get(VoCustomerCreditTransfer.class);
            List<Field13C> field13CList = mt103.getField13C();
            if (field13CList.size() > 0) {
                String dateStr = DateUtil.formatNow("yyyy-MM-dd'T'HH:mm:ss.SSS");
                for (int i=0; i<field13CList.size(); i++) {
                    Field13C field13C = field13CList.get(i);
                    String timeStr = dateStr.substring(0, 11)
                                    + field13C.getTime().substring(0,2)
                                    + ":" + field13C.getTime().substring(2,4)
                                    + ":00.000"
                                    + field13C.getSign()
                                    + field13C.getOffset().substring(0, 2)
                                    + ":" + field13C.getOffset().substring(2, 4);
                    XMLGregorianCalendar dateTime = DatatypeFactory.newInstance().newXMLGregorianCalendar(timeStr);
                    Date date = DateUtil.parseDate(dateTime);
                    if ("SNDTIME".equals(field13C.getCode())) {
                        customerCreditTransfer.setDebitDate(date);
                    } else if ("RNCTIME".equals(field13C.getCode())) {
                        customerCreditTransfer.setCreditDate(date);
                    } else if ("CLSTIME".equals(field13C.getCode())) {
                        customerCreditTransfer.setClsDate(date);
                    }
                }
            }
        } catch (Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}
