package com.brilliance.swift.mt2SwiftDto.pacs008001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.common.CategoryPurpose;
import com.brilliance.swift.vo.common.CategoryPurposeCode;
import com.brilliance.swift.vo.common.ExternalCreditorAgentInstructionCode;
import com.brilliance.swift.vo.common.InstructionForCreditAgent;
import com.prowidesoftware.swift.model.field.Field23E;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt1xx.MT103;

import java.util.List;

public class Pacs00801Parse23EField extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            VoCustomerCreditTransfer customerCreditTransfer = context.get(VoCustomerCreditTransfer.class);
            MT103 mt103 = (MT103)context.get(AbstractMT.class);
            List<Field23E> field23EList = mt103.getField23E();
            if (field23EList.size() > 0) {
                for (int i=0; i<field23EList.size(); i++) {
                    Field23E field23E = field23EList.get(i);
                    CategoryPurposeCode categoryPurposeCode = getCategoryPurposeByCode(field23E.getComponent(1));
                    if (categoryPurposeCode != null) {
                        CategoryPurpose categoryPurpose = new CategoryPurpose();
                        categoryPurpose.setCode(categoryPurposeCode);
                        customerCreditTransfer.setCategoryPurpose(categoryPurpose);
                    }
                    ExternalCreditorAgentInstructionCode creditorAgentInstructionCode = getExternalCreditorAgentInstructionByCode(field23E.getComponent(1));
                    if (creditorAgentInstructionCode != null) {
                        InstructionForCreditAgent instForCrdAgt = new InstructionForCreditAgent();
                        instForCrdAgt.setCode(creditorAgentInstructionCode);
                        if (field23E.getComponent(2) != null) {
                            instForCrdAgt.setInstrInf(field23E.getComponent(2));
                        }
                        customerCreditTransfer.setInstForCrdAgt(instForCrdAgt);
                    }
                }
            }
        } catch (Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}
