package com.brilliance.swift.mx2mt.mt103.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


public class Field26TGenerate extends AbstractMx2MtTagsGenerate {

    private static String name = "26T";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String proprietary = getXmlNodeValue(bodyHdrParentElementName, document, "CdtTrfTxInf.Purp.Prtry");
        if (StringUtil.isNotEmpty(proprietary)) {
            String regex = ".*:26T:(.*).*";
            Pattern p = Pattern.compile(regex);
            Matcher m = p.matcher(proprietary);
            if (m.find()) {
                /**
                 * group(0)就是指的整个串，group(1)指的是第一个括号里的东西，group(2)指的第二个括号里的东西
                 */
               String code = m.group(1);
                if (code.matches("[A-Z0-9]{3}")) {
                    tags.add(new Tag(name, code));
                }
            }
        }
    }
}
