package com.brilliance.swift.mx2mt.mt103.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**
 *
 */
public class Field50AGenerate extends AbstractMx2MtTagsGenerate {

    private static String name_A = "50A";

    private static String name_F = "50F";

    private static String name_K = "50K";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String partyPath = bodyHdrParentElementName + ".CdtTrfTxInf.Dbtr";
        String bicCode = mx_to_mtAnyBIC(bodyHdrParentElementName + ".CdtTrfTxInf.Dbtr");
        String countryCode = getXmlNodeValue(bodyHdrParentElementName, document, "CdtTrfTxInf.Dbtr.PstlAdr.Ctry");
        String name = getXmlNodeValue(bodyHdrParentElementName, document, "CdtTrfTxInf.Dbtr.Nm");
        int addressLineCount = getXmlNodeCounts(bodyHdrParentElementName, document, "CdtTrfTxInf.Dbtr.PstlAdr.AdrLine");
        String account = mx_to_mtAccount(bodyHdrParentElementName + ".CdtTrfTxInf.DbtrAcct");
        String value = "";
        if (StringUtil.isNotEmpty(bicCode)) {
            if (StringUtil.isNotEmpty(account)) {
                value = account + Mx2MtConstants.NEW_LINE + bicCode;
            } else {
                value = bicCode;
            }
            tags.add(new Tag(name_A, value));
        } else if (StringUtil.isNotEmpty(countryCode)) {
            String nameAddress = mx_to_mtFATFNameAndAddress(partyPath);
            if (StringUtil.isEmpty(account)) {
                account = mx_to_mtFATFIdentification(partyPath);
                if (StringUtil.isNotEmpty(account) && account.length() > 35) {
                    account = account.substring(0, 35);
                }
            }
            if (StringUtil.isEmpty(account)) {
                account = "/" + Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE;
            }
            value = account + Mx2MtConstants.NEW_LINE + nameAddress;
            tags.add(new Tag(name_F, value));
        } else if (addressLineCount > 0) {
            boolean structuredAddressIndicator = mx_to_mtAddressLineType(partyPath);
            if (structuredAddressIndicator) {
                String nameAddress = mx_to_mtFATFNameAndAddress2(partyPath);
                if (StringUtil.isEmpty(account)) {
                    account = mx_to_mtFATFIdentification(partyPath);
                    if (StringUtil.isNotEmpty(account) && account.length() > 35) {
                        account = account.substring(0, 35);
                    }
                }
                if (StringUtil.isEmpty(account)) {
                    account = "/" + Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE;
                }
                value = account + Mx2MtConstants.NEW_LINE + nameAddress;
                tags.add(new Tag(name_F, value));
            } else {
                String mtNameAddress = mx_to_mtFinancialInstitutionNameAndUnstructuredAddress(partyPath);
                if (StringUtil.isNotEmpty(account)) {
                    value = account + Mx2MtConstants.NEW_LINE + mtNameAddress;
                } else {
                    value = mtNameAddress;
                }
                tags.add(new Tag(name_K, value));
            }
        } else if (StringUtil.isNotEmpty(name)) {
            String mtNameAddress = mx_to_mtFinancialInstitutionNameAndUnstructuredAddress(partyPath);
            if (StringUtil.isNotEmpty(account)) {
                value = account + Mx2MtConstants.NEW_LINE + mtNameAddress;
            } else {
                value = mtNameAddress;
            }
            tags.add(new Tag(name_K, value));
        }
    }
}
