package com.brilliance.swift.mx2mt.mt103Retn.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**
 *70域取值规则：
 * 参数1：TxInf.RtrChain.UltmtCdtr
 * 参数2：TxInf.RtrChain.UltmtDbtr
 * 1.如果参数1和参数2都不存在，不做处理直接返回
 * 2.①如果参数1有值，/ULTB/MX_To_MTUltimateParty（CdtTrfTxInf.UltmtCdtr）,长度超过140就截图139位,最后一位给+
 *   ②如果参数2有值，/ULTD/MX_To_MTUltimateParty（CdtTrfTxInf.UltmtDbtr),长度超过140就截图139位,最后一位给+
 */
public class Field70Generate extends AbstractMx2MtTagsGenerate {

    private static String name = "70";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String mt70FullString = "";
        String mtUltimateCreditor = mx_to_mtUltimateParty(bodyHdrParentElementName + ".TxInf.RtrChain.UltmtCdtr");
        if (StringUtil.isNotEmpty(mtUltimateCreditor)) {
            String str = "/ULTB/" + mtUltimateCreditor;
            if (str.length() > 140) str = str.substring(0, 139) + "+";
            if (StringUtil.isEmpty(mt70FullString)) {
                mt70FullString += str;
            } else {
                mt70FullString += "//" + str;
            }
        }
        String mtUltimateDebtor = mx_to_mtUltimateParty(bodyHdrParentElementName + ".TxInf.RtrChain.UltmtDbtr");
        if (StringUtil.isNotEmpty(mtUltimateDebtor)) {
            String str = "/ULTD/" + mtUltimateDebtor;
            if (str.length() > 140) str = str.substring(0, 139) + "+";
            if (StringUtil.isEmpty(mt70FullString)) {
                mt70FullString += str;
            } else {
                mt70FullString += "//" + str;
            }
        }
        if (StringUtil.isNotEmpty(mt70FullString)) {
            String value = StringUtil.getStringByEnter(mt70FullString, 35, 4);
            tags.add(new Tag(name, value));
        }
    }
}