package com.brilliance.swift.mx2mt.mt192292.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.NumberUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.math.BigDecimal;
import java.util.List;

/**

 */
public class Field79Generate extends AbstractMx2MtTagsGenerate {

    private static String name_79 = "79";

    private static String name_32A = "32A";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String uetr = getXmlNodeValue(bodyHdrParentElementName, document, "FIToFIPmtCxlReq.Undrlyg.TxInf.OrgnlUETR");
        String filed79 = mXToMT79CANC(uetr, "FIToFIPmtCxlReq.Undrlyg.TxInf.CxlRsnInf");
        if (StringUtil.isNotEmpty(filed79)) {
            tags.add(new Tag(name_79, filed79));
            String dt = "";
            String amt = "";
            String ccy = "";
            String dateStr = getXmlNodeValue(bodyHdrParentElementName, document, "FIToFIPmtCxlReq.Undrlyg.TxInf.OrgnlIntrBkSttlmDt");
            dt = mXToMTDate(dateStr);
            String amtStr = getXmlNodeValue(bodyHdrParentElementName, document, "FIToFIPmtCxlReq.Undrlyg.TxInf.OrgnlIntrBkSttlmAmt");
            String ccyStr = getXmlNodeValue(bodyHdrParentElementName, document, "FIToFIPmtCxlReq.Undrlyg.TxInf.OrgnlIntrBkSttlmAmt@Ccy");
            if (StringUtil.isNotEmpty(amtStr)&&StringUtil.isNotEmpty(ccyStr)) {
                amt = NumberUtil.formatAmt(new BigDecimal(amtStr), ccyStr);
                ccy = ccyStr;
                tags.add(new Tag(name_32A, dt+ccy+amt));
            }
        }
    }
}
