package com.brilliance.swift.mx2mt.mt202cov202.impl.cov;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

public class Field70Generate extends AbstractMx2MtTagsGenerate {

    private static String name = "70";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String mt70FullString = "";
        String mtUltimateCreditor = mx_to_mtUltimateParty(bodyHdrParentElementName + ".CdtTrfTxInf.UndrlygCstmrCdtTrf.UltmtCdtr");
        if (StringUtil.isNotEmpty(mtUltimateCreditor)) {
            String str = "/ULTB/" + mtUltimateCreditor;
            if (str.length() > 140) str = str.substring(0, 139) + "+";
            if (StringUtil.isEmpty(mt70FullString)) {
                mt70FullString += str;
            } else {
                mt70FullString += "//" + str;
            }
        }
        String mtUltimateDebtor = mx_to_mtUltimateParty(bodyHdrParentElementName + ".CdtTrfTxInf.UndrlygCstmrCdtTrf.UltmtDbtr");
        if (StringUtil.isNotEmpty(mtUltimateDebtor)) {
            String str = "/ULTD/" + mtUltimateDebtor;
            if (str.length() > 140) str = str.substring(0, 139) + "+";
            if (StringUtil.isEmpty(mt70FullString)) {
                mt70FullString += str;
            } else {
                mt70FullString += "//" + str;
            }
        }
        String remittanceInfoUnstructured = getXmlNodeValue(bodyHdrParentElementName, document, "CdtTrfTxInf.UndrlygCstmrCdtTrf.RmtInf.Ustrd");
        if (StringUtil.isNotEmpty(remittanceInfoUnstructured)) {
            if (StringUtil.isEmpty(mt70FullString)) {
                mt70FullString += "/URI/" + remittanceInfoUnstructured;
            } else {
                mt70FullString += "///URI/" + remittanceInfoUnstructured;
            }
        }
        int remittanceInfoStructuredCount = getXmlNodeCounts(bodyHdrParentElementName, document, "CdtTrfTxInf.UndrlygCstmrCdtTrf.RmtInf.Strd");
        if (remittanceInfoStructuredCount > 0) {
            if (StringUtil.isEmpty(mt70FullString)) {
                mt70FullString += "/SRI/+";
            } else {
                mt70FullString += "///SRI/+";
            }
        }
        if (StringUtil.isNotEmpty(mt70FullString)) {
            String value = StringUtil.getStringByEnter(mt70FullString, 35, 4);
            tags.add(new Tag(name, value));
        }
    }
}
