package com.brilliance.swift.mx2mt.mt900910.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.DateUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

public class Field13DGenerate extends AbstractMx2MtTagsGenerate {

    private static String name = "13D";

    @Override
    public void tagGenerate() throws SwiftException {
        try {
            SwiftMessage swiftMessage = context.get(SwiftMessage.class);
            List<Tag> tags = swiftMessage.getBlock4().getTags();
            String bookDateStr = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Ntry.BookgDt");
            if (StringUtil.isNotEmpty(bookDateStr)) {
                SimpleDateFormat fmt = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
                Date bookDate = fmt.parse(bookDateStr);
                String dateStr = DateUtil.format(bookDate, "yyMMddHHmm");
                String timeOff = bookDateStr.substring(bookDateStr.length()-6);
                String[] timeOffs = timeOff.split(":");
                if (timeOffs.length == 2) {
                    String value = dateStr + timeOffs[0] + timeOffs[1];
                    tags.add(new Tag(name, value));
                }
            }
        } catch (ParseException e) {
            throw new SwiftException("ERROR", e.getMessage());
        }

    }
}
