package com.brilliance.swift.mx2mt.mt940950;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtCreator;
import com.brilliance.swift.mx2mt.Mx2MtContextIdentifier;
import com.brilliance.swift.mx2mt.Mx2MtTagsGenerate;
import com.brilliance.swift.mx2mt.mt940950.impl.*;
import com.brilliance.swift.util.XmlUtil;
import org.dom4j.Document;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class Mx2Mt940950Creator extends AbstractMx2MtCreator {

    @Override
    public void preProcess() {
        super.preProcess();
        Document document = (Document)context.get(Mx2MtContextIdentifier.MX_XMl_DOCUMENT, true);
        Map<String, String> parentElementMaps = XmlUtil.getParentElementMaps(document);
        context.set(Mx2MtContextIdentifier.APPHDR_PARENT_ELEMENT_NAME, parentElementMaps.get("AppHdr"));
        context.set(Mx2MtContextIdentifier.GRPHDR_PARENT_ELEMENT_NAME, parentElementMaps.get("GrpHdr"));
        context.set(Mx2MtContextIdentifier.BODY_PARENT_ELEMENT_NAME, parentElementMaps.get("Stmt"));
    }

    @Override
    public void withBlock2() throws SwiftException {
        //block2逻辑放在postProcess方法中
    }

    @Override
    public List<Mx2MtTagsGenerate> getGenerateTagList() {
        List<Mx2MtTagsGenerate> fieldsGenerateList = new ArrayList<>();
        fieldsGenerateList.add(new Field20Generate());
        fieldsGenerateList.add(new Field21Generate());
        fieldsGenerateList.add(new Field25aGenerate());
        fieldsGenerateList.add(new Field28CGenerate());
        fieldsGenerateList.add(new Field60Generate());
        fieldsGenerateList.add(new Field61Generate());
        fieldsGenerateList.add(new Field62Generate());
        fieldsGenerateList.add(new Field64Generate());
        fieldsGenerateList.add(new Field65Generate());
        fieldsGenerateList.add(new Field86Generate());

        return fieldsGenerateList;
    }

    @Override
    public void postProcess() throws SwiftException {
        super.withBlock2();
        super.postProcess();
    }

    @Override
    protected String getMtType() {
        String mtType940Flag = (String) context.get(Mx2MtContextIdentifier.MT_TYPE_940_FLAG, true);
        if (Mx2MtConstants.YES.equals(mtType940Flag)) {
            return Mx2MtConstants.MT_TYPE_940;
        } else {
            return Mx2MtConstants.MT_TYPE_950;
        }
    }
}
