package com.brilliance.swift.mx2mt.mt942.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**

 */
public class Field25Generate extends AbstractMx2MtTagsGenerate {

    private static String name_25 = "25";

    private static String name_25P = "25P";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String iban = getXmlNodeValue(bodyHdrParentElementName, document, "BkToCstmrAcctRpt.Rpt.Acct.Id.IBAN");
        String accountId = "";
        if(StringUtil.isNotEmpty(iban)){
            accountId = iban;
        }else {
            accountId = getXmlNodeValue(bodyHdrParentElementName, document, "BkToCstmrAcctRpt.Rpt.Acct.Id.Othr.Id");
        }
        String anyBic = getXmlNodeValue(bodyHdrParentElementName, document, "BkToCstmrAcctRpt.Rpt.Acct.Ownr.Id.OrgId.AnyBIC");
        if(StringUtil.isNotEmpty(anyBic)){
            tags.add(new Tag(name_25P,accountId+ Mx2MtConstants.NEW_LINE+anyBic));
        }else {
            tags.add(new Tag(name_25,accountId));
        }
    }
}
