package com.brilliance.swift.mx2mt.mt942.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.NumberUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.math.BigDecimal;
import java.util.List;

/**

 */
public class Field90DGenerate extends AbstractMx2MtTagsGenerate {

    private static String name = "90D";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String sum = getXmlNodeValue(bodyHdrParentElementName, document, "BkToCstmrAcctRpt.Rpt.TxsSummry.TtlDbtNtries.Sum");
        String nbOfNtries = getXmlNodeValue(bodyHdrParentElementName, document, "BkToCstmrAcctRpt.Rpt.TxsSummry.TtlDbtNtries.NbOfNtries");
        if(StringUtil.isNotEmpty(sum)&&StringUtil.isNotEmpty(nbOfNtries)) {
            String currency = getXmlNodeValue(bodyHdrParentElementName, document, "BkToCstmrAcctRpt.Rpt.Acct.Ccy");
            String amt = NumberUtil.formatAmt(new BigDecimal(sum), currency);
            if(amt.length()>15||nbOfNtries.length()>5){

            } else {
                tags.add(new Tag(name,nbOfNtries+currency+amt));
            }
        }
    }
}
