package com.brilliance.swift.swiftdto2mt.mt103.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.swiftdto2mt.AbstractSwiftDto2MtTagGenerate;
import com.brilliance.swift.swiftdto2mt.SwiftDto2MtContextIdentifier;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

public class Tag36Generate extends AbstractSwiftDto2MtTagGenerate {

    private String name = "36";

    @Override
    public void tagGenerate() throws SwiftException {
        VoCustomerCreditTransfer customerCreditTransfer = (VoCustomerCreditTransfer)context.get(SwiftDto2MtContextIdentifier.SWIFT_DTO_OBJ, true);
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        if (customerCreditTransfer.getExchangeRate() != null) {
            String exchangeRateStr = String.valueOf(customerCreditTransfer.getExchangeRate());
            if (exchangeRateStr.startsWith("-")) {
                exchangeRateStr = exchangeRateStr.replace("-", "");
            }
            if(exchangeRateStr.indexOf(".") > 0){//去掉小数点后不需要的0
                exchangeRateStr = exchangeRateStr.replaceAll("0+?$", "");
            }
            exchangeRateStr = exchangeRateStr.replace(".", ",");//小数点替换成,
            tags.add(new Tag(name, exchangeRateStr));
        }
    }
}
