package com.brilliance.swift.swiftdto2mt.mt202.impl;


import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.swiftdto2mt.AbstractSwiftDto2MtTagGenerate;
import com.brilliance.swift.swiftdto2mt.SwiftDto2MtContextIdentifier;
import com.brilliance.swift.util.DateUtil;
import com.brilliance.swift.vo.VoFinancialInstitutionCreditTransfer;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

public class Tag13CGenerate extends AbstractSwiftDto2MtTagGenerate {

    private String name = "13C";

    @Override
    public void tagGenerate() throws SwiftException {
        VoFinancialInstitutionCreditTransfer financialInstitutionCreditTransfer = (VoFinancialInstitutionCreditTransfer)context.get(SwiftDto2MtContextIdentifier.SWIFT_DTO_OBJ, true);
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        if (financialInstitutionCreditTransfer.getDebitDate() != null) {
            String dateStr = DateUtil.format(financialInstitutionCreditTransfer.getDebitDate(), "HHmm");
            tags.add(new Tag(name, "/SNDTIME/"+dateStr+"+0800"));
        }
        if (financialInstitutionCreditTransfer.getCreditDate() != null) {
            String dateStr = DateUtil.format(financialInstitutionCreditTransfer.getCreditDate(), "HHmm");
            tags.add(new Tag(name, "/RNCTIME/"+dateStr+"+0800"));
        }
        if (financialInstitutionCreditTransfer.getClsDate() != null) {
            String dateStr = DateUtil.format(financialInstitutionCreditTransfer.getClsDate(), "HHmm");
            tags.add(new Tag(name, "/CLSTIME/"+dateStr+"+0800"));
        }
    }
}
