package com.brilliance.swift.swiftdto2mt.mt202.impl.cov;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.swiftdto2mt.AbstractSwiftDto2MtTagGenerate;
import com.brilliance.swift.swiftdto2mt.SwiftDto2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.VoFinancialInstitutionCreditTransfer;
import com.brilliance.swift.vo.common.RemittanceInformation;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

public class Tag70Generate extends AbstractSwiftDto2MtTagGenerate {

    private String name = "70";

    @Override
    public void tagGenerate() throws SwiftException {
        VoFinancialInstitutionCreditTransfer financialInstitutionCreditTransfer = (VoFinancialInstitutionCreditTransfer)context.get(SwiftDto2MtContextIdentifier.SWIFT_DTO_OBJ, true);
        VoCustomerCreditTransfer customerCreditTransfer = financialInstitutionCreditTransfer.getUnderCustomerCreditTransfer();
        if (customerCreditTransfer == null) return;
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        RemittanceInformation remittanceInfo = customerCreditTransfer.getRemittanceInfo();
        if (remittanceInfo != null && remittanceInfo.getUnstructured().size() > 0) {
            String value = StringUtil.getStringByEnter(remittanceInfo.getUnstructured().get(0), 35, 4);
            tags.add(new Tag(name, value));
        }
    }
}