package com.brilliance.swift.swiftdto2mt.mt900910;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.swiftdto2mt.AbstractSwiftDto2MtCreator;
import com.brilliance.swift.swiftdto2mt.SwiftDto2MtContextIdentifier;
import com.brilliance.swift.swiftdto2mt.SwiftDto2MtTagGenerate;
import com.brilliance.swift.swiftdto2mt.mt900910.impl.*;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.BankToCustomerDebitCreditNotification;
import com.brilliance.swift.vo.common.TransactionReference;
import com.prowidesoftware.swift.model.SwiftBlock3;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.ArrayList;
import java.util.List;

import static com.brilliance.swift.constants.Mx2MtConstants.MT_TYPE_900;
import static com.brilliance.swift.constants.Mx2MtConstants.MT_TYPE_910;

public class SwiftDto2Mt900910Creator extends AbstractSwiftDto2MtCreator {

    @Override
    public void withBlock3() throws SwiftException {
        super.withBlock3();
        SwiftBlock3 block3 = context.get(SwiftMessage.class).getBlock3();
        BankToCustomerDebitCreditNotification bankToCustomerDebitCreditNotification = (BankToCustomerDebitCreditNotification)context.get(SwiftDto2MtContextIdentifier.SWIFT_DTO_OBJ, true);
        TransactionReference txnRef = bankToCustomerDebitCreditNotification.getTxnRef();
        if (txnRef != null && StringUtil.isNotEmpty(txnRef.getUetr())) {
            block3.getTags().add(new Tag("121", txnRef.getUetr()));
        }
    }

    @Override
    public List<SwiftDto2MtTagGenerate> getGenerateTagList() {
        List<SwiftDto2MtTagGenerate> list = new ArrayList<>();
        list.add(new Tag13Generate());
        list.add(new Tag20Generate());
        list.add(new Tag21Generate());
        list.add(new Tag25aGenerate());
        list.add(new Tag32AGenerate());
        list.add(new Tag50aGenerate());
        list.add(new Tag52aGenerate());
        list.add(new Tag56aGenerate());
        list.add(new Tag72Generate());
        return list;
    }

    @Override
    protected String getMtType() {
        BankToCustomerDebitCreditNotification bankToCustomerDebitCreditNotification = (BankToCustomerDebitCreditNotification)context.get(SwiftDto2MtContextIdentifier.SWIFT_DTO_OBJ, true);
        if("DBIT".equals(bankToCustomerDebitCreditNotification.getCdtDbtCode())){
            return MT_TYPE_900;
        }else {
            return MT_TYPE_910;
        }
    }

}
