package com.brilliance.swift.swiftdto2mt.mt900910.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.swiftdto2mt.AbstractSwiftDto2MtTagGenerate;
import com.brilliance.swift.swiftdto2mt.SwiftDto2MtContextIdentifier;
import com.brilliance.swift.util.DateUtil;
import com.brilliance.swift.util.NumberUtil;
import com.brilliance.swift.vo.BankToCustomerDebitCreditNotification;
import com.brilliance.swift.vo.common.CcyFormatAmount;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.Date;
import java.util.List;


public class Tag32AGenerate extends AbstractSwiftDto2MtTagGenerate {

    private String name = "32A";

    @Override
    public void tagGenerate() throws SwiftException {
        try {
            BankToCustomerDebitCreditNotification bankToCustomerDebitCreditNotification = (BankToCustomerDebitCreditNotification)context.get(SwiftDto2MtContextIdentifier.SWIFT_DTO_OBJ, true);
            SwiftMessage swiftMessage = context.get(SwiftMessage.class);
            List<Tag> tags = swiftMessage.getBlock4().getTags();
            Date valueDate = bankToCustomerDebitCreditNotification.getValueDate();
            CcyFormatAmount valueAmount = bankToCustomerDebitCreditNotification.getValueAmount();
            if(valueDate != null && valueAmount != null){
                String dateStr = DateUtil.format(valueDate, "yyMMdd");
                String ccy = valueAmount.getCcy();
                String amt = NumberUtil.formatAmt(valueAmount.getAmt(), ccy);
                tags.add(new Tag(name, dateStr+ccy+amt));
            }
        }catch (Exception e){
            throw new SwiftException("ERROR", e.getMessage());
        }


    }
}
