package com.brilliance.swift.vo.common;

public enum ChargeForEnum {

    /**
     * All transaction charges are to be borne by the debtor.
     *
     */
    DEBT("OUR"),

    /**
     * All transaction charges are to be borne by the creditor.
     *
     */
    CRED("BEN"),

    /**
     * In a credit transfer context, means that transaction charges on the sender side are to be borne by the debtor, transaction charges on the receiver side are to be borne by the creditor. In a direct debit context, means that transaction charges on the sender side are to be borne by the creditor, transaction charges on the receiver side are to be borne by the debtor.
     *
     */
    SHAR("SHA"),

    /**
     * Charges are to be applied following the rules agreed in the service level and/or scheme.
     *
     */
    SLEV("SLEV");

    ChargeForEnum(String s) {
        this.desc = s;
    }

    public String value() {
        return name();
    }

    String desc;

    public String desc() {
        return desc;
    }
}
