package com.brilliance.swift.vo.common;

public class PartyAccount {

    private String account;

    /**
     * pattern: [A-Z]{2,2}[0-9]{2,2}[a-zA-Z0-9]{1,30}
     * International Bank Account Number (IBAN)
     * - identifier used internationally by financial institutions to uniquely identify the
     * account of a customer. Further specifications of the format and content of the
     * IBAN can be found in the standard ISO 13616 "Banking and related financial services
     * - International Bank Account Number (IBAN)" version 1997-10-01, or later revisions.
     */
    private String ibanAcct;

    private String acctCcy;

    private String acctName;

    private AcctType acctType;

    private AcctSchemeType acctSehemeType;

    public String getAccount() {
        return account;
    }

    public void setAccount(String account) {
        this.account = account;
    }

    public String getIbanAcct() {
        return ibanAcct;
    }

    public void setIbanAcct(String ibanAcct) {
        this.ibanAcct = ibanAcct;
    }

    public String getAcctCcy() {
        return acctCcy;
    }

    public void setAcctCcy(String acctCcy) {
        this.acctCcy = acctCcy;
    }

    public String getAcctName() {
        return acctName;
    }

    public void setAcctName(String acctName) {
        this.acctName = acctName;
    }

    public AcctType getAcctType() {
        return acctType;
    }

    public void setAcctType(AcctType acctType) {
        this.acctType = acctType;
    }

    public AcctSchemeType getAcctSehemeType() {
        return acctSehemeType;
    }

    public void setAcctSehemeType(AcctSchemeType acctSehemeType) {
        this.acctSehemeType = acctSehemeType;
    }
}
