package com.brilliance.swift.vo.common;

public enum ReturnReasonCode {

    AC01("IncorrectAccountNumber"),
    AC03("InvalidCreditorAccountNumber"),
    AC04("ClosedAccountNumber"),
    AC06("BlockedAccount"),
    AC13("InvalidDebtorAccountType"),
    AC14("InvalidAgent"),
    AC15("AccountDetailsChanged"),
    AC16("AccountInSequestration"),
    AC17("AccountInLiquidation"),
    AG01("TransactionForbidden"),
    AG02("InvalidBankOperationCode"),
    AM01("ZeroAmount"),
    AM02("NotAllowedAmount"),
    AM03("NotAllowedCurrency"),
    AM04("InsufficientFunds"),
    AM05("Duplication"),
    AM06("TooLowAmount"),
    AM07("BlockedAmount"),
    AM09("WrongAmount"),
    AM10("InvalidControlSum"),
    ARDT("AlreadyReturnedTransaction"),
    BE01("InconsistenWithEndCustomer"),
    BE04("MissingCreditorAddress"),
    BE05("UnrecognisedInitiatingParty"),
    BE06("UnknownEndCustomer"),
    BE07("MissingDebtorAddress"),
    BE08("BankError"),
    CN01("AuthorisationCancelled"),
    CNOR("CreditorBankIsNotRegistered"),
    CNPC("CashNotPickedUp"),
    CURR("IncorrectCurrency"),
    CUST("RequestedByCustomer"),
    DNOR("DebtorBankIsNotRegistered"),
    DS28("ReturnForTechnicalReason"),
    DT01("InvalidDate"),
    DT02("ChequeExpired"),
    ED01("CorrespondentBankNotPossible"),
    ED03("BalanceInfoRequest"),
    ED05("SettlementFailed"),
    EMVL("EMVLiabilityShift"),
    ERIN("ERIOptionNotSupported"),
    FF05("InvalidLocalInstrumentCode"),
    FOCR("FollowingCancellationRequest"),
    FR01("Fraud"),
    FRTR("FinalResponseMandateCancelled"),
    MD01("NoMandate"),
    MD02("MissingMandatoryInformationInMandate"),
    MD06("RefundRequestByEndCustomer"),
    MD07("EndCustomerDeceased"),
    MS02("NotSpecifiedReasonCustomerGenerated"),
    MS03("NotSpecifiedReasonAgentGenerated"),
    NARR("Narrative"),
    NOAS("NoAnswerFromCustomer"),
    NOCM("NotCompliant"),
    NOOR("NoOriginalTransactionReceived"),
    PINL("PINLiabilityShift"),
    RC01("BankIdentifierIncorrect"),
    RC07("InvalidCreditorBICIdentifier"),
    RF01("NotUniqueTransactionReference"),
    RR01("MissingDebtorAccountOrIdentification"),
    RR02("MissingDebtorNameOrAddress"),
    RR03("MissingCreditorNameOrAddress"),
    RR04("RegulatoryReason"),
    RUTA("ReturnUponUnableToApply"),
    SL01("SpecificServiceOfferedByDebtorAgent"),
    SL02("SpecificServiceOfferedByCreditorAgent"),
    SL11("CreditorNotOnWhitelistOfDebtor"),
    SL12("CreditorOnBlacklistOfDebtor"),
    SL13("MaximumNumberOfDirectDebitTransactionsExceeded"),
    SL14("MaximumDirectDebitTransactionAmountExceeded"),
    SP01("PaymentStopped"),
    SP02("PreviouslyStopped"),
    SVNR("ServiceNotRendered"),
    TM01("CutOffTime"),
    TRAC("RemovedFromTracking"),
    UPAY("UnduePayment"),
    AGNT("IncorrectAgent"),
    FF06("InvalidCategoryPurposeCode"),
    RC08("InvalidClearingSystemMemberIdentifier"),
    BE11("InvalidCreditorCountry"),
    BE17("InvalidCreditorIdentificationCode"),
    AC02("InvalidDebtorAccountNumber"),
    RR11("InvalidDebtorAgentServiceIdentification"),
    BE10("InvalidDebtorCountry"),
    BE16("InvalidDebtorIdentificationCode"),
    RC11("InvalidIntermediaryAgent"),
    RR12("InvalidPartyIdentification"),
    FF03("InvalidPaymentTypeInformation"),
    FF07("InvalidPurpose"),
    FF04("InvalidServiceLevelCode"),
    RR09("InvalidStructuredCreditorReference"),
    RR05("RegulatoryInformationInvalid"),
    RR07("RemittanceInformationInvalid"),
    RR08("RemittanceInformationTruncated"),
    RR06("TaxInformationInvalid"),
    AG07("UnsuccesfulDirectDebit"),
    G004("CreditPendingFunds"),
    MD05("CollectionNotDue"),
    AC07("ClosedCreditorAccountNumber");

    ReturnReasonCode(String s) {}
    public String value() {
        return name();
    }

}
