package com.brilliance.swift.vo.common;

public enum SettlementMethodCode {

    /**
     * Settlement is done by the agent instructed to execute a payment instruction.
     *
     */
    INDA,

    /**
     * Settlement is done by the agent instructing and forwarding the payment to the next party in the payment chain.
     *
     */
    INGA,

    /**
     * Settlement is done through a cover payment.
     *
     */
    COVE,

    /**
     * Settlement is done through a payment clearing system.
     *
     */
    CLRG;

    public String value() {
        return name();
    }

    public static SettlementMethodCode fromValue(String v) {
        return valueOf(v);
    }
}
