package com.brilliance.mx2mt.mt950;

import com.prowidesoftware.swift.model.mx.MxCamt05300102;
import com.prowidesoftware.swift.model.mx.dic.*;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import java.io.File;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

public class MessageCreationMxCamt05300102 {

    public static void main(String[] args) throws DatatypeConfigurationException {
        MxCamt05300102 mxCamt05300102 = new MxCamt05300102();

        BankToCustomerStatementV02 bkToCstmrStmt = new BankToCustomerStatementV02();
        //set groupHeader
        GroupHeader42 grpHdr = new GroupHeader42();
        grpHdr.setMsgId("00010013800002001234");
        GregorianCalendar cal = new GregorianCalendar();
        cal.setTime(new Date());
        XMLGregorianCalendar creDtTm = DatatypeFactory.newInstance().newXMLGregorianCalendar(cal);
        grpHdr.setCreDtTm(creDtTm);
        grpHdr.setAddtlInf("EODY");
        bkToCstmrStmt.setGrpHdr(grpHdr);
        //set Stmt
        AccountStatement2 stmt = new AccountStatement2();
        stmt.setId("1123456789012317092013");
        stmt.setElctrncSeqNb(new BigDecimal("178"));
        stmt.setLglSeqNb(new BigDecimal("178"));
        stmt.setCreDtTm(creDtTm);
        DateTimePeriodDetails frToDt = new DateTimePeriodDetails();
        frToDt.setFrDtTm(creDtTm);
        frToDt.setToDtTm(creDtTm);
        stmt.setFrToDt(frToDt);
        ReportingSource1Choice rptgSrc = new ReportingSource1Choice();
        rptgSrc.setCd("GPRD");
        stmt.setRptgSrc(rptgSrc);
        //SET ACCOUNT INFO
        CashAccount20 acct = new CashAccount20();
        AccountIdentification4Choice id = new AccountIdentification4Choice();
        id.setIBAN("S15612345678012345");
        acct.setId(id);
        acct.setCcy("USD");
        BranchAndFinancialInstitutionIdentification4 svcr = new BranchAndFinancialInstitutionIdentification4();
        FinancialInstitutionIdentification7 finInstnId = new FinancialInstitutionIdentification7();
        finInstnId.setBIC("BJWHS12X");
        svcr.setFinInstnId(finInstnId);
        acct.setSvcr(svcr);
        stmt.setAcct(acct);
        //SET CashBalance
        List<CashBalance3> balList = new ArrayList<>();
        CashBalance3 cashBalance301 = new CashBalance3();
        BalanceType12 tp01 = new BalanceType12();
        BalanceType5Choice cdOrPrtry01 = new BalanceType5Choice();
        cdOrPrtry01.setCd(BalanceType12Code.OPBD);
        tp01.setCdOrPrtry(cdOrPrtry01);
        cashBalance301.setTp(tp01);
        ActiveOrHistoricCurrencyAndAmount amt01 = new ActiveOrHistoricCurrencyAndAmount();
        amt01.setCcy("USD");
        amt01.setValue(new BigDecimal("120274.34"));
        cashBalance301.setAmt(amt01);
        cashBalance301.setCdtDbtInd(CreditDebitCode.CRDT);
        DateAndDateTimeChoice dt01 = new DateAndDateTimeChoice();
        dt01.setDt(creDtTm);
        cashBalance301.setDt(dt01);
        stmt.addBal(cashBalance301);

        CashBalance3 cashBalance302 = new CashBalance3();
        BalanceType12 tp02 = new BalanceType12();
        BalanceType5Choice cdOrPrtry02 = new BalanceType5Choice();
        cdOrPrtry02.setCd(BalanceType12Code.CLBD);
        tp02.setCdOrPrtry(cdOrPrtry02);
        cashBalance302.setTp(tp02);
        ActiveOrHistoricCurrencyAndAmount amt02 = new ActiveOrHistoricCurrencyAndAmount();
        amt02.setCcy("USD");
        amt02.setValue(new BigDecimal("123456.29"));
        cashBalance302.setAmt(amt02);
        cashBalance302.setCdtDbtInd(CreditDebitCode.CRDT);
        DateAndDateTimeChoice dt02 = new DateAndDateTimeChoice();
        dt02.setDt(creDtTm);
        cashBalance302.setDt(dt02);
        stmt.addBal(cashBalance302);

        CashBalance3 cashBalance303 = new CashBalance3();
        BalanceType12 tp03 = new BalanceType12();
        BalanceType5Choice cdOrPrtry03 = new BalanceType5Choice();
        cdOrPrtry03.setCd(BalanceType12Code.CLAV);
        tp03.setCdOrPrtry(cdOrPrtry03);
        cashBalance303.setTp(tp03);
        ActiveOrHistoricCurrencyAndAmount amt03 = new ActiveOrHistoricCurrencyAndAmount();
        amt03.setCcy("USD");
        amt03.setValue(new BigDecimal("119609.29"));
        cashBalance303.setAmt(amt03);
        cashBalance303.setCdtDbtInd(CreditDebitCode.CRDT);
        DateAndDateTimeChoice dt03 = new DateAndDateTimeChoice();
        dt03.setDt(creDtTm);
        cashBalance303.setDt(dt03);
        stmt.addBal(cashBalance303);

        //Ntry
        ReportEntry2 reportEntry201 = new ReportEntry2();
        reportEntry201.setNtryRef("1309170100003901154395");
        ActiveOrHistoricCurrencyAndAmount nTryAmt = new ActiveOrHistoricCurrencyAndAmount();
        nTryAmt.setCcy("USD");
        nTryAmt.setValue(new BigDecimal("393.17"));
        reportEntry201.setAmt(nTryAmt);
        reportEntry201.setCdtDbtInd(CreditDebitCode.DBIT);
        reportEntry201.setSts(EntryStatus2Code.BOOK);
        DateAndDateTimeChoice bookgDt = new DateAndDateTimeChoice();
        bookgDt.setDt(creDtTm);
        reportEntry201.setBookgDt(bookgDt);
        DateAndDateTimeChoice valDt = new DateAndDateTimeChoice();
        valDt.setDt(creDtTm);
        reportEntry201.setValDt(valDt);
        reportEntry201.setAcctSvcrRef("1309170100000390154395");
        BankTransactionCodeStructure4 bkTxCd = new BankTransactionCodeStructure4();
        ProprietaryBankTransactionCodeStructure1 prtry = new ProprietaryBankTransactionCodeStructure1();
        prtry.setCd("123456789");
        bkTxCd.setPrtry(prtry);
        reportEntry201.setBkTxCd(bkTxCd);
        //EntryDetails1
        EntryDetails1 entryDetail1 = new EntryDetails1();

        EntryTransaction2 entryTransaction2 = new EntryTransaction2();
        TransactionReferences2 refs = new TransactionReferences2();
        refs.setEndToEndId("S100000189-735");
        refs.setTxId("1309170100000390154395");
        entryTransaction2.setRefs(refs);
        AmountAndCurrencyExchange3 amtDtls = new AmountAndCurrencyExchange3();
        AmountAndCurrencyExchangeDetails3 instdAmt = new AmountAndCurrencyExchangeDetails3();
        ActiveOrHistoricCurrencyAndAmount amt001 = new ActiveOrHistoricCurrencyAndAmount();
        amt001.setCcy("USD");
        amt001.setValue(new BigDecimal("393.17"));
        instdAmt.setAmt(amt001);
        amtDtls.setInstdAmt(instdAmt);
        AmountAndCurrencyExchangeDetails3 txAmt = new AmountAndCurrencyExchangeDetails3();
        txAmt.setAmt(amt001);
        amtDtls.setTxAmt(txAmt);
        entryTransaction2.setAmtDtls(amtDtls);
        entryTransaction2.setAddtlTxInf("PLACI LOVECNAMENSKIH STORITEV");
        entryDetail1.addTxDtls(entryTransaction2);
        reportEntry201.addNtryDtls(entryDetail1);
        stmt.addNtry(reportEntry201);
        bkToCstmrStmt.addStmt(stmt);
        mxCamt05300102.setBkToCstmrStmt(bkToCstmrStmt);

        try {
            JAXBContext jaxbContext = JAXBContext.newInstance(MxCamt05300102.class);

            Marshaller marshaller = jaxbContext.createMarshaller();

            marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);

            File file = new File("D:/test/"+MxCamt05300102.class.getSimpleName()+".xml");
            if (!file.exists()) {
                file.createNewFile();
            }
            marshaller.marshal(mxCamt05300102, file);
        } catch (JAXBException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
}
