
package com.prowidesoftware.swift.model.mx;

import com.prowidesoftware.swift.model.MxSwiftMessage;
import com.prowidesoftware.swift.model.mx.dic.*;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import javax.xml.bind.annotation.*;
/**
 * Class for acmt.036.001.01 ISO 20022 message.
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Document", propOrder = {
    "acctSwtchTermntnSwtch"
})
@XmlRootElement(name = "Document", namespace = "urn:iso:std:iso:20022:tech:xsd:acmt.036.001.01")
public class MxAcmt03600101
    extends AbstractMX
{

    @XmlElement(name = "AcctSwtchTermntnSwtch", required = true)
    protected AccountSwitchTerminationSwitchV01 acctSwtchTermntnSwtch;
    public final static transient String BUSINESS_PROCESS = "acmt";
    public final static transient int FUNCTIONALITY = 36;
    public final static transient int VARIANT = 1;
    public final static transient int VERSION = 1;
    @SuppressWarnings("rawtypes")
    public final static transient Class[] _classes = new Class[] {AccountSwitchDetails1 .class, AccountSwitchTerminationSwitchV01 .class, BalanceTransferWindow1Code.class, MessageIdentification1 .class, MxAcmt03600101 .class, ResponseDetails1 .class, SupplementaryData1 .class, SupplementaryDataEnvelope1 .class, SwitchStatus1Code.class, SwitchType1Code.class };
    public final static transient String NAMESPACE = "urn:iso:std:iso:20022:tech:xsd:acmt.036.001.01";

    public MxAcmt03600101() {
        super();
    }

    /**
     * Creates the MX object parsing the parameter String with the XML content
     * 
     */
    public MxAcmt03600101(final String xml) {
        this();
        MxAcmt03600101 tmp = parse(xml);
        acctSwtchTermntnSwtch = tmp.getAcctSwtchTermntnSwtch();
    }

    /**
     * Creates the MX object parsing the raw content from the parameter MxSwiftMessage
     * 
     */
    public MxAcmt03600101(final MxSwiftMessage mxSwiftMessage) {
        this(mxSwiftMessage.message());
    }

    /**
     * Gets the value of the acctSwtchTermntnSwtch property.
     * 
     * @return
     *     possible object is
     *     {@link AccountSwitchTerminationSwitchV01 }
     *     
     */
    public AccountSwitchTerminationSwitchV01 getAcctSwtchTermntnSwtch() {
        return acctSwtchTermntnSwtch;
    }

    /**
     * Sets the value of the acctSwtchTermntnSwtch property.
     * 
     * @param value
     *     allowed object is
     *     {@link AccountSwitchTerminationSwitchV01 }
     *     
     */
    public MxAcmt03600101 setAcctSwtchTermntnSwtch(AccountSwitchTerminationSwitchV01 value) {
        this.acctSwtchTermntnSwtch = value;
        return this;
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public boolean equals(Object that) {
        return EqualsBuilder.reflectionEquals(this, that);
    }

    @Override
    public int hashCode() {
        return HashCodeBuilder.reflectionHashCode(this);
    }

    @Override
    public String getBusinessProcess() {
        return BUSINESS_PROCESS;
    }

    @Override
    public int getFunctionality() {
        return FUNCTIONALITY;
    }

    @Override
    public int getVariant() {
        return VARIANT;
    }

    @Override
    public int getVersion() {
        return VERSION;
    }

    /**
     * Creates the MX object parsing the raw content from the parameter XML
     * 
     */
    public static MxAcmt03600101 parse(String xml) {
        return ((MxAcmt03600101) MxReadImpl.parse(MxAcmt03600101 .class, xml, _classes));
    }

    /**
     * Creates the MX object parsing the raw content from the parameter XML with injected read implementation
     * @since 9.0.1
     * 
     * @param parserImpl an MX unmarshall implementation
     */
    public static MxAcmt03600101 parse(String xml, MxRead parserImpl) {
        return ((MxAcmt03600101) parserImpl.read(MxAcmt03600101 .class, xml, _classes));
    }

    @Override
    public String getNamespace() {
        return NAMESPACE;
    }

    @Override
    @SuppressWarnings("rawtypes")
    public Class[] getClasses() {
        return _classes;
    }

    /**
     * Creates an MxAcmt03600101 messages from its JSON representation.
     * <p>
     * For generic conversion of JSON into the corresponding MX instance 
     * see {@link AbstractMX#fromJson(String)}
     * 
     * @since 7.10.2
     * 
     * @param json a JSON representation of an MxAcmt03600101 message
     * @return
     *     a new instance of MxAcmt03600101
     */
    public final static MxAcmt03600101 fromJson(String json) {
        return AbstractMX.fromJson(json, MxAcmt03600101 .class);
    }

}
