
package com.prowidesoftware.swift.model.mx;

import com.prowidesoftware.swift.model.MxSwiftMessage;
import com.prowidesoftware.swift.model.mx.dic.Camt03400102;
import com.prowidesoftware.swift.model.mx.dic.Case;
import com.prowidesoftware.swift.model.mx.dic.CaseAssignment;
import com.prowidesoftware.swift.model.mx.dic.ProprietaryData;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import javax.xml.bind.annotation.*;


/**
 * Class for camt.034.001.02 ISO 20022 message.
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Document", propOrder = {
    "camt03400102"
})
@XmlRootElement(name = "Document", namespace = "urn:swift:xsd:camt.034.001.02")
public class MxCamt03400102
    extends AbstractMX
{

    @XmlElement(name = "camt.034.001.02", required = true)
    protected Camt03400102 camt03400102;
    public final static transient String BUSINESS_PROCESS = "camt";
    public final static transient int FUNCTIONALITY = 34;
    public final static transient int VARIANT = 1;
    public final static transient int VERSION = 2;
    @SuppressWarnings("rawtypes")
    public final static transient Class[] _classes = new Class[] {Camt03400102 .class, Case.class, CaseAssignment.class, MxCamt03400102 .class, ProprietaryData.class };
    public final static transient String NAMESPACE = "urn:swift:xsd:camt.034.001.02";

    public MxCamt03400102() {
        super();
    }

    /**
     * Creates the MX object parsing the parameter String with the XML content
     * 
     */
    public MxCamt03400102(final String xml) {
        this();
        MxCamt03400102 tmp = parse(xml);
        camt03400102 = tmp.getCamt03400102();
    }

    /**
     * Creates the MX object parsing the raw content from the parameter MxSwiftMessage
     * 
     */
    public MxCamt03400102(final MxSwiftMessage mxSwiftMessage) {
        this(mxSwiftMessage.message());
    }

    /**
     * Gets the value of the camt03400102 property.
     * 
     * @return
     *     possible object is
     *     {@link Camt03400102 }
     *     
     */
    public Camt03400102 getCamt03400102() {
        return camt03400102;
    }

    /**
     * Sets the value of the camt03400102 property.
     * 
     * @param value
     *     allowed object is
     *     {@link Camt03400102 }
     *     
     */
    public MxCamt03400102 setCamt03400102(Camt03400102 value) {
        this.camt03400102 = value;
        return this;
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public boolean equals(Object that) {
        return EqualsBuilder.reflectionEquals(this, that);
    }

    @Override
    public int hashCode() {
        return HashCodeBuilder.reflectionHashCode(this);
    }

    @Override
    public String getBusinessProcess() {
        return BUSINESS_PROCESS;
    }

    @Override
    public int getFunctionality() {
        return FUNCTIONALITY;
    }

    @Override
    public int getVariant() {
        return VARIANT;
    }

    @Override
    public int getVersion() {
        return VERSION;
    }

    /**
     * Creates the MX object parsing the raw content from the parameter XML
     * 
     */
    public static MxCamt03400102 parse(String xml) {
        return ((MxCamt03400102) MxReadImpl.parse(MxCamt03400102 .class, xml, _classes));
    }

    /**
     * Creates the MX object parsing the raw content from the parameter XML with injected read implementation
     * @since 9.0.1
     * 
     * @param parserImpl an MX unmarshall implementation
     */
    public static MxCamt03400102 parse(String xml, MxRead parserImpl) {
        return ((MxCamt03400102) parserImpl.read(MxCamt03400102 .class, xml, _classes));
    }

    @Override
    public String getNamespace() {
        return NAMESPACE;
    }

    @Override
    @SuppressWarnings("rawtypes")
    public Class[] getClasses() {
        return _classes;
    }

    /**
     * Creates an MxCamt03400102 messages from its JSON representation.
     * <p>
     * For generic conversion of JSON into the corresponding MX instance 
     * see {@link AbstractMX#fromJson(String)}
     * 
     * @since 7.10.2
     * 
     * @param json a JSON representation of an MxCamt03400102 message
     * @return
     *     a new instance of MxCamt03400102
     */
    public final static MxCamt03400102 fromJson(String json) {
        return AbstractMX.fromJson(json, MxCamt03400102 .class);
    }

}
