
package com.prowidesoftware.swift.model.mx;

import com.prowidesoftware.swift.model.MxSwiftMessage;
import com.prowidesoftware.swift.model.mx.dic.MessageReference;
import com.prowidesoftware.swift.model.mx.dic.Pain99800101;
import com.prowidesoftware.swift.model.mx.dic.ProprietaryData;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import javax.xml.bind.annotation.*;


/**
 * Class for pain.998.001.01 ISO 20022 message.
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Document", propOrder = {
    "pain99800101"
})
@XmlRootElement(name = "Document", namespace = "urn:swift:xsd:pain.998.001.01")
public class MxPain99800101
    extends AbstractMX
{

    @XmlElement(name = "pain.998.001.01", required = true)
    protected Pain99800101 pain99800101;
    public final static transient String BUSINESS_PROCESS = "pain";
    public final static transient int FUNCTIONALITY = 998;
    public final static transient int VARIANT = 1;
    public final static transient int VERSION = 1;
    @SuppressWarnings("rawtypes")
    public final static transient Class[] _classes = new Class[] {MessageReference.class, MxPain99800101 .class, Pain99800101 .class, ProprietaryData.class };
    public final static transient String NAMESPACE = "urn:swift:xsd:pain.998.001.01";

    public MxPain99800101() {
        super();
    }

    /**
     * Creates the MX object parsing the parameter String with the XML content
     * 
     */
    public MxPain99800101(final String xml) {
        this();
        MxPain99800101 tmp = parse(xml);
        pain99800101 = tmp.getPain99800101();
    }

    /**
     * Creates the MX object parsing the raw content from the parameter MxSwiftMessage
     * 
     */
    public MxPain99800101(final MxSwiftMessage mxSwiftMessage) {
        this(mxSwiftMessage.message());
    }

    /**
     * Gets the value of the pain99800101 property.
     * 
     * @return
     *     possible object is
     *     {@link Pain99800101 }
     *     
     */
    public Pain99800101 getPain99800101() {
        return pain99800101;
    }

    /**
     * Sets the value of the pain99800101 property.
     * 
     * @param value
     *     allowed object is
     *     {@link Pain99800101 }
     *     
     */
    public MxPain99800101 setPain99800101(Pain99800101 value) {
        this.pain99800101 = value;
        return this;
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public boolean equals(Object that) {
        return EqualsBuilder.reflectionEquals(this, that);
    }

    @Override
    public int hashCode() {
        return HashCodeBuilder.reflectionHashCode(this);
    }

    @Override
    public String getBusinessProcess() {
        return BUSINESS_PROCESS;
    }

    @Override
    public int getFunctionality() {
        return FUNCTIONALITY;
    }

    @Override
    public int getVariant() {
        return VARIANT;
    }

    @Override
    public int getVersion() {
        return VERSION;
    }

    /**
     * Creates the MX object parsing the raw content from the parameter XML
     * 
     */
    public static MxPain99800101 parse(String xml) {
        return ((MxPain99800101) MxReadImpl.parse(MxPain99800101 .class, xml, _classes));
    }

    /**
     * Creates the MX object parsing the raw content from the parameter XML with injected read implementation
     * @since 9.0.1
     * 
     * @param parserImpl an MX unmarshall implementation
     */
    public static MxPain99800101 parse(String xml, MxRead parserImpl) {
        return ((MxPain99800101) parserImpl.read(MxPain99800101 .class, xml, _classes));
    }

    @Override
    public String getNamespace() {
        return NAMESPACE;
    }

    @Override
    @SuppressWarnings("rawtypes")
    public Class[] getClasses() {
        return _classes;
    }

    /**
     * Creates an MxPain99800101 messages from its JSON representation.
     * <p>
     * For generic conversion of JSON into the corresponding MX instance 
     * see {@link AbstractMX#fromJson(String)}
     * 
     * @since 7.10.2
     * 
     * @param json a JSON representation of an MxPain99800101 message
     * @return
     *     a new instance of MxPain99800101
     */
    public final static MxPain99800101 fromJson(String json) {
        return AbstractMX.fromJson(json, MxPain99800101 .class);
    }

}
