
package com.prowidesoftware.swift.model.mx.sys;

import com.prowidesoftware.swift.model.MxSwiftMessage;
import com.prowidesoftware.swift.model.mx.AbstractMX;
import com.prowidesoftware.swift.model.mx.MxRead;
import com.prowidesoftware.swift.model.mx.MxReadImpl;
import com.prowidesoftware.swift.model.mx.sys.dic.QueueSharingModeRequest;
import com.prowidesoftware.swift.model.mx.sys.dic.SharingMode;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import javax.xml.bind.annotation.*;


/**
 * Class for xsys.028.001.01 ISO 20022 message.
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Document", propOrder = {
    "xsys02800101"
})
@XmlRootElement(name = "Document", namespace = "urn:swift:xsd:xsys.028.001.01")
public class MxXsys02800101
    extends AbstractMX
{

    @XmlElement(name = "xsys.028.001.01", required = true)
    protected QueueSharingModeRequest xsys02800101;
    public final static transient String BUSINESS_PROCESS = "xsys";
    public final static transient int FUNCTIONALITY = 28;
    public final static transient int VARIANT = 1;
    public final static transient int VERSION = 1;
    @SuppressWarnings("rawtypes")
    public final static transient Class[] _classes = new Class[] {MxXsys02800101 .class, QueueSharingModeRequest.class, SharingMode.class };
    public final static transient String NAMESPACE = "urn:swift:xsd:xsys.028.001.01";

    public MxXsys02800101() {
        super();
    }

    /**
     * Creates the MX object parsing the parameter String with the XML content
     * 
     */
    public MxXsys02800101(final String xml) {
        this();
        MxXsys02800101 tmp = parse(xml);
        xsys02800101 = tmp.getXsys02800101();
    }

    /**
     * Creates the MX object parsing the raw content from the parameter MxSwiftMessage
     * 
     */
    public MxXsys02800101(final MxSwiftMessage mxSwiftMessage) {
        this(mxSwiftMessage.message());
    }

    /**
     * Gets the value of the xsys02800101 property.
     * 
     * @return
     *     possible object is
     *     {@link QueueSharingModeRequest }
     *     
     */
    public QueueSharingModeRequest getXsys02800101() {
        return xsys02800101;
    }

    /**
     * Sets the value of the xsys02800101 property.
     * 
     * @param value
     *     allowed object is
     *     {@link QueueSharingModeRequest }
     *     
     */
    public MxXsys02800101 setXsys02800101(QueueSharingModeRequest value) {
        this.xsys02800101 = value;
        return this;
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public boolean equals(Object that) {
        return EqualsBuilder.reflectionEquals(this, that);
    }

    @Override
    public int hashCode() {
        return HashCodeBuilder.reflectionHashCode(this);
    }

    @Override
    public String getBusinessProcess() {
        return BUSINESS_PROCESS;
    }

    @Override
    public int getFunctionality() {
        return FUNCTIONALITY;
    }

    @Override
    public int getVariant() {
        return VARIANT;
    }

    @Override
    public int getVersion() {
        return VERSION;
    }

    /**
     * Creates the MX object parsing the raw content from the parameter XML
     * 
     */
    public static MxXsys02800101 parse(String xml) {
        return ((MxXsys02800101) MxReadImpl.parse(MxXsys02800101 .class, xml, _classes));
    }

    /**
     * Creates the MX object parsing the raw content from the parameter XML with injected read implementation
     * @since 9.0.1
     * 
     * @param parserImpl an MX unmarshall implementation
     */
    public static MxXsys02800101 parse(String xml, MxRead parserImpl) {
        return ((MxXsys02800101) parserImpl.read(MxXsys02800101 .class, xml, _classes));
    }

    @Override
    public String getNamespace() {
        return NAMESPACE;
    }

    @Override
    @SuppressWarnings("rawtypes")
    public Class[] getClasses() {
        return _classes;
    }

    /**
     * Creates an MxXsys02800101 messages from its JSON representation.
     * <p>
     * For generic conversion of JSON into the corresponding MX instance 
     * see {@link AbstractMX#fromJson(String)}
     * 
     * @since 7.10.2
     * 
     * @param json a JSON representation of an MxXsys02800101 message
     * @return
     *     a new instance of MxXsys02800101
     */
    public final static MxXsys02800101 fromJson(String json) {
        return AbstractMX.fromJson(json, MxXsys02800101 .class);
    }

}
